import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Scanner;

class hypothesis {
	
	int idColor;
	double prob;
	
     hypothesis(int idColor, double prob) {
    	 idColor = idColor;
    	 prob = prob;
     }
}

class rule {
	
	
	public int idColor1;
	public int idColor2;
	public int idColor3;
	
	rule(int c1, int c2, int c3) {
		idColor1 = c1;
		idColor2 = c2;
		idColor3 = c3;
	}
	
}

public class joan_robust {

	static int MIN_VALUE = -999999;
	
	public static int addColor(Hashtable<String, Integer> T,String []R, String w) {
	  
    
		if (T.containsKey(w))
			return T.get(w);
		
		T.put(w, T.size());
		R[T.size()-1] = w;
		return T.size()-1;
	}

	
	public static void main(String []args){
		Scanner sc = new Scanner(System.in);
		
		//int [][]rules = new int[MAXCOLORS][MAXCOLORS];
		
		Hashtable<String, Integer> T = new Hashtable<String, Integer>();
		String []R = new String[1000];
	 
    int MAXCOLORS;  
		int nRules = sc.nextInt();
		ArrayList<rule> rules = new ArrayList<rule>();
		
		for (int i = 0; i < nRules; ++i) {
			String a = sc.next();
			String b = sc.next();
			String c = sc.next();
			
			int ia = addColor(T,R, a);
			int ib = addColor(T,R, b);
			int ic = addColor(T, R, c);
			
			rules.add(new rule(ia,ib,ic));
			if(ia != ib)
				rules.add(new rule(ib,ia,ic));
			
		}
		
		//NumCases
		int nCases = sc.nextInt();
		
		for(int c = 0; c < nCases; ++c) {
			int nColors = sc.nextInt();
			MAXCOLORS = T.size();
			//3-D Matrix for CKY
			double M[][][] = new double[nColors][nColors][MAXCOLORS];
			for(int i = 0; i < nColors; ++i)
				for(int j = 0; j < nColors; ++j)
					for(int k = 0; k < MAXCOLORS; ++k)
						M[i][j][k] = MIN_VALUE;
			
			for (int i = 0; i < nColors; ++i) {
				String sToken = sc.next();
				while(!sToken.equals("END")) {
					
					int iColor = addColor(T, R, sToken);
					double prob = sc.nextDouble();
					sToken = sc.next();
					M[i][i][iColor] = Math.log(prob);
				}
			}
			//CKY algorithm
			for (int i = 1; i < nColors; ++i) {
				//System.out.println("Iteration "+i);
				//System.out.println(String.format("Diagonal %d",i));
				for (int j = 0; j < nColors-i; ++j) {
					//System.out.println(String.format("[%d,%d]", j, i+j));
					for (int k = 0; k < i; ++k){
						for (rule r: rules) {
							int cA = r.idColor1;
							int cB = r.idColor2;
							
							//System.out.println("Colors:  "+cA+" "+cB);
							double probA = M[j][j+k][cA];
							double probB = M[j+k+1][i+j][cB];
							
							if ( probA > MIN_VALUE && probB > MIN_VALUE) {
								//M[j][i+j][r.idColor3] += probA*probB;
								M[j][i+j][r.idColor3] = Math.max(M[j][i+j][r.idColor3],probA+probB);
							}
						} // rules
					// System.out.println(String.format("[%d,%d]<-[%d,%d],[%d,%d]", j, i+j, j, j+k, j+k+1, i+j));
					}
				}
							
			}//CYKJ
			//Buscar el maximo final
			double maxProb = MIN_VALUE;
			int maxColor = -1;
			for (int i = 0; i < MAXCOLORS; ++i){
				if(M[0][nColors-1][i] > maxProb){
					maxProb = M[0][nColors-1][i];
					maxColor = i;
				}
			}
			if(maxColor == -1)
				System.out.println("GAMEOVER");
			else
				System.out.println(R[maxColor]);
		}//TestCase
	}
	
}
