/* Genera grafos para colorear */
/* E.V.R. 2013 */
/* V.09 sin ruido */


#include <stdio.h>
#include <stdlib.h>

#define MAXNODOS 3000

int grafo[MAXNODOS][MAXNODOS], color[MAXNODOS];
int num_nodos,prob_aristas,ruido, i , j ;

int volcar_fichero(){
  FILE *df;
 

  df = fopen("zonas_vivopark.txt","w");
  if (df == NULL)
   return -1;

  fprintf(df, "%d", num_nodos);

  for(i=0;i<num_nodos;i++)
    for(j=i+1; j< num_nodos; j++) {
      if (grafo[i][j]) {
          fprintf(df,"\n%d-%d", i+1 , j+1) ;
          if (ruido && (rand()%10 < 1)) fprintf(df,"\n%d-%d", j+1 , i+1);
      }

    };



  fclose(df);
  return 0;
}


void inicializar()
{
  
/* Inicializa los nodos con colores (0-3) aleatorios */

for (i=0; i<num_nodos; i++) {color[i]= rand() % 4; printf("\ncolor de %d = %d", i,color[i]); }

/* Genera aristas para nodos de distintos colores */
/* prob_aristas sirve para indicar si habr pocas o muchas aristas */

 
for (i=0; i <num_nodos; i++)  
  for(j=i+1; j<num_nodos; j++)
   if (color[i] != color[j]) {
       /* Se generaran mas aristas cuando prob_arista sea 10 */
      grafo[i][j] = ((rand() % 10) < prob_aristas) ; printf("\n[%d,%d]= %d",i,j, grafo[i][j]); }
   else { grafo[i][j] = 0; printf("\n[%d,%d]= %d",i,j, grafo[i][j]) ;}
}

int main(){

srand(time(NULL));

printf("Nmero de nodos (1-%d): ",MAXNODOS);
scanf("%d", &num_nodos) ;
printf("Porcentaje de aristas (0-10): ");
scanf("%d", &prob_aristas) ;
printf("Ruido (0=no, 1=si):");
scanf("%d", &ruido) ;
inicializar();

volcar_fichero();

 return 0;

}
